'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".styles_reallySimpleInfiniteScroll__YFyfx {\n  overflow: auto; }\n";
var styles = {"reallySimpleInfiniteScroll":"styles_reallySimpleInfiniteScroll__YFyfx"};
styleInject(css_248z);

/**
 * @type {string}
 */

Object.prototype.toString.call({});
/**
 * Tests whether a value is undefined or not.
 *
 * @param {*} value A value
 * @return {boolean} True value is undefined, false otherwise.
 */

function isUndefined(value) {
  return typeof value === "undefined";
}
/**
 * Tests if the given value is an int.
 *
 * @param {*} value The value.
 * @return {boolean} True if value is an int, false otherwise.
 */

function isInt(value) {
  return Number.isInteger(value);
}

/*
 * Copyright (c) 2021 Anton Bagdatyev (Tonix)
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */
/**
 * Tests if a DOM element has a vertical scrollbar.
 *
 * @param {Element} elem The DOM element.
 * @return {boolean} True it has a vertical scrollbar, false otherwise.
 */

function hasVerticalScrollbar(elem) {
  const hasVerticalScrollbar = elem.scrollHeight > elem.clientHeight;
  return hasVerticalScrollbar;
}
/**
 * Tests if a DOM element has a horizontal scrollbar.
 *
 * @param {Element} elem The DOM element.
 * @return {boolean} True it has a horizontal scrollbar, false otherwise.
 */

function hasHorizontalScrollbar(elem) {
  const hasHorizontalScrollbar = elem.scrollWidth > elem.clientWidth;
  return hasHorizontalScrollbar;
}

/*
 * Copyright (c) 2021 Anton Bagdatyev (Tonix)
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */
/**
 * Escapes special characters for a JS regex.
 *
 * @see https://stackoverflow.com/questions/3115150/how-to-escape-regular-expression-special-characters-using-javascript#answer-9310752
 *
 * @param {string} text The string to escape.
 * @return {string} The same string with special regex characters escaped.
 */

function escapeRegExp(text) {
  return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
}
/**
 * Trim characters from the beginning and end of a string.
 *
 * @param {string} str The string.
 * @param {string} characterMask Character mask.
 * @param {Object} options Options.
 * @param {Object.boolean} options.shouldTrimLeft "true" to trim left (defaults to "true" if omitted).
 * @param {Object.boolean} options.shouldTrimRight "true" to trim right (defaults to "true" if omitted).
 * @return {string} The trimmed string.
 */

function trimCharacterMask(str, characterMask, options = {}) {
  if (typeof characterMask === "undefined") {
    characterMask = " ";
  }

  const escapedCharacterMask = escapeRegExp(characterMask);
  const shouldTrimLeft = typeof options.shouldTrimLeft === "undefined" || options.shouldTrimLeft;
  const shouldTrimRight = typeof options.shouldTrimRight === "undefined" || options.shouldTrimRight;
  const regexParts = [];

  if (shouldTrimLeft) {
    regexParts[regexParts.length] = "^[" + escapedCharacterMask + "]+";
  }

  if (shouldTrimRight) {
    regexParts[regexParts.length] = "[" + escapedCharacterMask + "]+$";
  }

  const regex = new RegExp(regexParts.join("|"), "gm");
  return str.replace(regex, "");
}
/**
 * Alias of "trimCharacterMask".
 * Trim characters from the beginning and end of a string.
 *
 * @param {string} str The string.
 * @param {string} characterMask Character mask.
 * @return {string} The trimmed string.
 */

function trim(str, characterMask) {
  return trimCharacterMask(str, characterMask);
}

/*
 * Copyright (c) 2021 Anton Bagdatyev (Tonix)
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */
/**
 * Debounces a function.
 *
 * @param {Function} fn A function.
 * @param {number} wait Wait interval in milliseconds.
 * @return {Function} A new function, debounced.
 */

function debounce(fn, wait) {
  let timer = void 0;
  return function (...args) {
    !isUndefined(timer) && clearTimeout(timer);
    timer = setTimeout(function () {
      fn(...args);
    }, wait);
  };
}

/**
 * React JS utility functions.
 */

/**
 * Returns a class name string.
 *
 * @param {*} componentClassName Default class name of a component (a string) or a falsy value which evaluates to an empty string.
 * @param {...*} classNames Additional, optional list of strings of class names or falsy values to ignore.
 * @return {string} The class name string.
 */

function classNames(componentClassName) {
  for (var _len = arguments.length, classNames = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    classNames[_key - 1] = arguments[_key];
  }

  return classNames.reduce(function (componentClassName, className) {
    return trim("".concat(componentClassName || "", " ").concat(className || ""));
  }, componentClassName);
}

var ReallySimpleInfiniteScroll = /*#__PURE__*/function (_React$Component) {
  _inherits(ReallySimpleInfiniteScroll, _React$Component);

  var _super = _createSuper(ReallySimpleInfiniteScroll);

  function ReallySimpleInfiniteScroll(props) {
    var _this;

    _classCallCheck(this, ReallySimpleInfiniteScroll);

    _this = _super.call(this, props);
    _this.handleScroll = _this.handleScroll.bind(_assertThisInitialized(_this));
    _this.onScrollStop = debounce(_this.onScrollStop.bind(_assertThisInitialized(_this)), 100);
    _this.componentDidUpdateHasScrolledToStart = false;
    _this.isLoading = false;
    _this.isScrolling = false;
    _this.lastScrollStopPromise = null;
    _this.lastScrollStopPromiseResolve = null;
    _this.node = /*#__PURE__*/React__default['default'].createRef();
    return _this;
  }

  _createClass(ReallySimpleInfiniteScroll, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.scrollToStart();
    }
  }, {
    key: "getNode",
    value: function getNode() {
      return this.node && this.node.current;
    }
  }, {
    key: "getSnapshotBeforeUpdate",
    value: function getSnapshotBeforeUpdate(prevProps) {
      var doesNotHaveChildren = !this.props.children;

      if (doesNotHaveChildren ? prevProps.length < this.props.length : prevProps.children.length < this.props.children.length) {
        var list = this.node.current;
        var axis = this.axis();
        var scrollDimProperty = this.scrollDimProperty(axis);
        var scrollProperty = this.scrollProperty(axis);
        var scrollDelta = list[scrollDimProperty] - list[scrollProperty];
        return {
          scrollDelta: scrollDelta
        };
      }

      return null;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var doesNotHaveChildren = !this.props.children;

      if (doesNotHaveChildren ? prevProps.length !== this.props.length : prevProps.children.length !== this.props.children.length) {
        if (!this.componentDidUpdateHasScrolledToStart) {
          this.scrollToStart();
          this.componentDidUpdateHasScrolledToStart = true;
        }
      } // prettier-ignore


      if (this.isLoading && (prevProps.isInfiniteLoading && !this.props.isInfiniteLoading // eslint-disable-next-line operator-linebreak
      || (this.props.hasMore || prevProps.hasMore // eslint-disable-next-line operator-linebreak
      ) && (!this.props.children ? prevProps.length !== this.props.length : prevProps.children.length !== this.props.children.length))) {
        if (this.props.displayInverse && snapshot) {
          var list = this.node.current;
          var axis = this.axis();
          var scrollDimProperty = this.scrollDimProperty(axis);
          var scrollProperty = this.scrollProperty(axis);
          var scrollDelta = snapshot.scrollDelta;
          var scrollTo = list[scrollDimProperty] - scrollDelta;
          this.scrollTo(scrollProperty, scrollTo);
        }

        this.isLoading = false;
      }
    }
  }, {
    key: "loadingComponentRenderer",
    value: function loadingComponentRenderer() {
      var _this$props = this.props,
          loadingComponent = _this$props.loadingComponent,
          _this$props$reallySim = _this$props.reallySimpleInfiniteScrollLoadingComponentClassName,
          reallySimpleInfiniteScrollLoadingComponentClassName = _this$props$reallySim === void 0 ? "really-simple-infinite-scroll-loading-component" : _this$props$reallySim;
      return /*#__PURE__*/React__default['default'].createElement("div", {
        className: reallySimpleInfiniteScrollLoadingComponentClassName,
        key: -2
      }, loadingComponent);
    }
  }, {
    key: "axis",
    value: function axis() {
      return this.props.axis === "x" ? "x" : "y";
    }
  }, {
    key: "scrollProperty",
    value: function scrollProperty(axis) {
      return axis === "y" ? "scrollTop" : "scrollLeft";
    }
  }, {
    key: "offsetProperty",
    value: function offsetProperty(axis) {
      return axis === "y" ? "offsetHeight" : "offsetWidth";
    }
  }, {
    key: "clientDimProperty",
    value: function clientDimProperty(axis) {
      return axis === "y" ? "clientHeight" : "clientWidth";
    }
  }, {
    key: "scrollDimProperty",
    value: function scrollDimProperty(axis) {
      return axis === "y" ? "scrollHeight" : "scrollWidth";
    }
  }, {
    key: "scrollToStart",
    value: function scrollToStart() {
      var axis = this.axis();
      this.scrollTo(this.scrollProperty(axis), !this.props.displayInverse ? 0 : this.scrollDimProperty(axis));
    }
  }, {
    key: "scrollToEnd",
    value: function scrollToEnd() {
      var axis = this.axis();
      this.scrollTo(this.scrollProperty(axis), !this.props.displayInverse ? this.scrollDimProperty(axis) : 0);
    }
  }, {
    key: "scrollTo",
    value: function scrollTo(scrollProperty, scrollPositionOrPropertyOfScrollable) {
      var scrollableContentNode = this.node.current;

      if (scrollableContentNode) {
        scrollableContentNode[scrollProperty] = isInt(scrollPositionOrPropertyOfScrollable) ? scrollPositionOrPropertyOfScrollable : scrollableContentNode[scrollPositionOrPropertyOfScrollable];
      }
    }
    /**
     * @see https://developer.mozilla.org/en-US/docs/Web/API/Element/scrollIntoView#parameters
     */

  }, {
    key: "scrollToId",
    value: function scrollToId(id) {
      var _this$props2, _this$props2$itemIdRe, _this$props2$itemIdRe2;

      var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          _ref$alignToTop = _ref.alignToTop,
          alignToTop = _ref$alignToTop === void 0 ? true : _ref$alignToTop,
          _ref$scrollIntoViewOp = _ref.scrollIntoViewOptions,
          scrollIntoViewOptions = _ref$scrollIntoViewOp === void 0 ? void 0 : _ref$scrollIntoViewOp;

      if ((_this$props2 = this.props) !== null && _this$props2 !== void 0 && (_this$props2$itemIdRe = _this$props2.itemIdRefMap) !== null && _this$props2$itemIdRe !== void 0 && (_this$props2$itemIdRe2 = _this$props2$itemIdRe[id]) !== null && _this$props2$itemIdRe2 !== void 0 && _this$props2$itemIdRe2.current) {
        this.props.itemIdRefMap[id].current.scrollIntoView(scrollIntoViewOptions || alignToTop);
      }
    }
  }, {
    key: "scrollStopPromise",
    value: function scrollStopPromise() {
      return this.isScrolling && this.lastScrollStopPromise || Promise.resolve();
    }
  }, {
    key: "onScrollStop",
    value: function onScrollStop(callback) {
      callback();
      this.isScrolling = false;
      this.lastScrollStopPromise = null;
      this.lastScrollStopPromiseResolve = null;
    }
  }, {
    key: "handleScroll",
    value: function handleScroll(e) {
      var _this2 = this;

      var _this$props3 = this.props,
          isInfiniteLoading = _this$props3.isInfiniteLoading,
          hasMore = _this$props3.hasMore,
          infiniteLoadBeginEdgeOffset = _this$props3.infiniteLoadBeginEdgeOffset,
          displayInverse = _this$props3.displayInverse;
      this.isScrolling = true;
      this.lastScrollStopPromise = this.lastScrollStopPromise || new Promise(function (resolve) {
        _this2.lastScrollStopPromiseResolve = resolve;
      });
      this.onScrollStop(function () {
        _this2.lastScrollStopPromiseResolve && _this2.lastScrollStopPromiseResolve();
      });
      this.props.onScroll && this.props.onScroll(e);

      if (this.props.onInfiniteLoad && (!isUndefined(hasMore) ? hasMore : !isInfiniteLoading) && this.node.current && !this.isLoading) {
        var axis = this.axis();
        var scrollableContentNode = this.node.current;
        var scrollProperty = this.scrollProperty(axis);
        var offsetProperty = this.offsetProperty(axis);
        var scrollDimProperty = this.scrollDimProperty(axis);
        var currentScroll = scrollableContentNode[scrollProperty];
        var currentDim = scrollableContentNode[offsetProperty];
        var scrollDim = scrollableContentNode[scrollDimProperty];
        var finalInfiniteLoadBeginEdgeOffset = !isUndefined(infiniteLoadBeginEdgeOffset) ? infiniteLoadBeginEdgeOffset : currentDim / 2;
        var thresoldWasReached = false;

        if (!displayInverse) {
          var clientDimProperty = this.clientDimProperty(axis);
          var clientDim = scrollableContentNode[clientDimProperty];
          thresoldWasReached = currentScroll + clientDim + finalInfiniteLoadBeginEdgeOffset >= scrollDim;
        } else {
          thresoldWasReached = currentScroll <= finalInfiniteLoadBeginEdgeOffset;
        }

        if (thresoldWasReached) {
          this.isLoading = true;
          this.props.onInfiniteLoad();
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          _this$props4$children = _this$props4.children,
          children = _this$props4$children === void 0 ? void 0 : _this$props4$children,
          displayInverse = _this$props4.displayInverse,
          isInfiniteLoading = _this$props4.isInfiniteLoading,
          className = _this$props4.className,
          _this$props4$reallySi = _this$props4.reallySimpleInfiniteScrollClassName,
          reallySimpleInfiniteScrollClassName = _this$props4$reallySi === void 0 ? "really-simple-infinite-scroll" : _this$props4$reallySi,
          hasMore = _this$props4.hasMore;
      return /*#__PURE__*/React__default['default'].createElement("div", {
        className: classNames(styles.reallySimpleInfiniteScroll, reallySimpleInfiniteScrollClassName, className),
        ref: this.node,
        onScroll: this.handleScroll,
        onMouseOver: this.props.onInfiniteScrollMouseOver,
        onMouseOut: this.props.onInfiniteScrollMouseOut,
        onMouseEnter: this.props.onInfiniteScrollMouseEnter,
        onMouseLeave: this.props.onInfiniteScrollMouseLeave
      }, (hasMore || isInfiniteLoading) && displayInverse && this.loadingComponentRenderer(), children, (hasMore || isInfiniteLoading) && !displayInverse && this.loadingComponentRenderer());
    }
  }], [{
    key: "hasScrollbarFunction",
    value: function hasScrollbarFunction(axis) {
      return axis === "y" ? hasVerticalScrollbar : hasHorizontalScrollbar;
    }
  }]);

  return ReallySimpleInfiniteScroll;
}(React__default['default'].Component);

exports.ReallySimpleInfiniteScroll = ReallySimpleInfiniteScroll;
//# sourceMappingURL=index.js.map
